<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Generated by Apache Maven Doxia at Jan 20, 2013 ( $Revision$ ) -->
<!-- $HeadURL: https://svn.apache.org/repos/asf/httpcomponents/maven-skin/trunk/src/main/resources/META-INF/maven/site.vm $ -->
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <title>HttpClient - HttpComponents HttpClient Examples</title>
    <style type="text/css" media="all">
      @import url("./css/maven-base.css");
      @import url("./css/maven-theme.css");
      @import url("./css/site.css");
    </style>
    <link rel="stylesheet" href="./css/print.css" type="text/css" media="print" />
    <meta name="Date-Revision-yyyymmdd" content="20130120" />
    <meta http-equiv="Content-Language" content="en" />
        
        </head>
  <body class="composite">
    <div id="banner">
                        <a href="http://www.apache.org/" id="bannerLeft">
                                        <img src="http://www.apache.org/images/asf_logo_wide.gif" alt="Apache" />
                </a>
                                            <a href="../" id="bannerRight">
                                                <img src="../images/logos/httpcomponents.png" alt="HttpComponents" />
                </a>
            <div class="clear">
        <hr/>
      </div>
    </div>
    <div id="breadcrumbs">
            
        
                <div class="xleft">
        <span id="publishDate">Last Published: 2013-01-20</span>
                  &nbsp;| <span id="projectVersion">Version: 4.3-alpha1</span>
                      </div>
            <div class="xright">                    <a href="http://www.apache.org/" class="externalLink" title="Apache">Apache</a>
            |
                        <a href="../index.html" title="HttpComponents">HttpComponents</a>
              
        
      </div>
      <div class="clear">
        <hr/>
      </div>
    </div>
    <div id="leftColumn">
      <div id="navcolumn">
             
        
                                <h5>HttpComponents</h5>
                  <ul>
                  <li class="none">
                          <a href="../scp:/people.apache.org/www/hc.apache.org/index.html" title="Home">Home</a>
            </li>
                  <li class="none">
                          <a href="http://www.apache.org/licenses/" class="externalLink" title="License">License</a>
            </li>
                  <li class="none">
                          <a href="../scp:/people.apache.org/www/hc.apache.org/downloads.cgi" title="Download">Download</a>
            </li>
                  <li class="none">
                          <a href="../scp:/people.apache.org/www/hc.apache.org/mail.html" title="Mailing Lists">Mailing Lists</a>
            </li>
                  <li class="none">
                          <a href="../scp:/people.apache.org/www/hc.apache.org/user-docs.html" title="User documents">User documents</a>
            </li>
                  <li class="none">
                          <a href="../scp:/people.apache.org/www/hc.apache.org/dev-docs.html" title="Developer documents">Developer documents</a>
            </li>
                  <li class="none">
                          <a href="http://wiki.apache.org/HttpComponents/" class="externalLink" title="Wiki (external)">Wiki (external)</a>
            </li>
                  <li class="none">
                          <a href="http://www.apache.org/security/" class="externalLink" title="Security">Security</a>
            </li>
          </ul>
                       <h5>HttpClient Overview</h5>
                  <ul>
                  <li class="none">
                          <a href="index.html" title="Description">Description</a>
            </li>
                  <li class="none">
                          <a href="quickstart.html" title="Quick Start">Quick Start</a>
            </li>
          </ul>
                       <h5>Documentation</h5>
                  <ul>
                  <li class="none">
                          <a href="tutorial/html/index.html" title="Tutorial">Tutorial</a>
            </li>
                  <li class="none">
            <strong>Examples</strong>
          </li>
                  <li class="none">
                          <a href="primer.html" title="Client HTTP Programming Primer">Client HTTP Programming Primer</a>
            </li>
                  <li class="none">
                          <a href="ntlm.html" title="NTLM Guide">NTLM Guide</a>
            </li>
                  <li class="none">
                          <a href="logging.html" title="Logging">Logging</a>
            </li>
          </ul>
                       <h5>Modules</h5>
                  <ul>
                  <li class="none">
                          <a href="httpclient/index.html" title="HttpClient">HttpClient</a>
            </li>
                  <li class="none">
                          <a href="httpmime/index.html" title="HttpMime">HttpMime</a>
            </li>
                  <li class="none">
                          <a href="httpclient-cache/index.html" title="HttpClient Cache">HttpClient Cache</a>
            </li>
                  <li class="none">
                          <a href="fluent-hc/index.html" title="Fluent HC">Fluent HC</a>
            </li>
          </ul>
                       <h5>Project Documentation</h5>
                  <ul>
                                                                                                                          <li class="collapsed">
                          <a href="project-info.html" title="Project Information">Project Information</a>
                  </li>
          </ul>
                       <h5>ASF</h5>
                  <ul>
                  <li class="none">
                          <a href="http://www.apache.org" class="externalLink" title="ASF Home Page">ASF Home Page</a>
            </li>
                  <li class="none">
                          <a href="http://www.apache.org/foundation/" class="externalLink" title="Foundation">Foundation</a>
            </li>
                  <li class="none">
                          <a href="http://www.apache.org/foundation/sponsorship.html" class="externalLink" title="Sponsor Apache">Sponsor Apache</a>
            </li>
                  <li class="none">
                          <a href="http://www.apache.org/foundation/thanks.html" class="externalLink" title="Thanks">Thanks</a>
            </li>
          </ul>
                                                                                                                   <a href="http://www.apache.org/events/current-event.html" title="ApacheCon" class="poweredBy">
        <img class="poweredBy"  alt="ApacheCon" src="http://www.apache.org/events/current-event-125x125.png"    />
      </a>
                                                                                                    <a href="http://maven.apache.org/" title="Maven" class="poweredBy">
        <img class="poweredBy"  alt="Maven" src="http://maven.apache.org/images/logos/maven-feather.png"    />
      </a>
                       
        
            </div>
    </div>
    <div id="bodyColumn">
      <div id="contentBox">
        <!-- ==================================================================== --><!-- Licensed to the Apache Software Foundation (ASF) under one --><!-- or more contributor license agreements.  See the NOTICE file --><!-- distributed with this work for additional information --><!-- regarding copyright ownership.  The ASF licenses this file --><!-- to you under the Apache License, Version 2.0 (the --><!-- "License"); you may not use this file except in compliance --><!-- with the License.  You may obtain a copy of the License at --><!--  --><!-- http://www.apache.org/licenses/LICENSE-2.0 --><!--  --><!-- Unless required by applicable law or agreed to in writing, --><!-- software distributed under the License is distributed on an --><!-- "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY --><!-- KIND, either express or implied.  See the License for the --><!-- specific language governing permissions and limitations --><!-- under the License. --><!-- ==================================================================== --><!--  --><!-- This software consists of voluntary contributions made by many --><!-- individuals on behalf of the Apache Software Foundation.  For more --><!-- information on the Apache Software Foundation, please see --><!-- <http://www.apache.org/>. --><div class="section"><h2>HttpClient Examples<a name="HttpClient_Examples"></a></h2><ul><li><a href="./httpclient/examples/org/apache/http/examples/client/ClientWithResponseHandler.java">Response handling</a><p>This example demonstrates how to process HTTP responses using a response handler. This is the recommended way of executing HTTP requests and processing HTTP responses. This approach enables the caller to concentrate on the process of digesting HTTP responses and to delegate the task of system resource deallocation to HttpClient. The use of an HTTP response guarantees that the underlying HTTP connection will be released back to the connection manager automatically in all cases.</p></li><li><a href="./httpclient/examples/org/apache/http/examples/client/ClientConnectionRelease.java">Manual connection release</a><p>This example demonstrates how to ensure the release of the underlying HTTP connection back to the connection manager in case of a manual processing of HTTP responses.</p></li><li><a href="./httpclient/examples/org/apache/http/examples/client/ClientConfiguration.java">HttpClient configuration</a><p>This example demonstrates how to customize and configure the most common aspects of HTTP request execution and connection management.</p></li><li><a href="./httpclient/examples/org/apache/http/examples/client/ClientAbortMethod.java">Abort method</a><p>This example demonstrates how to abort an HTTP request before its normal completion.</p></li><li><a href="./httpclient/examples/org/apache/http/examples/client/ClientAuthentication.java">Client authentication</a><p>This example uses HttpClient to execute an HTTP request against a target site that requires user authentication. </p></li><li><a href="./httpclient/examples/org/apache/http/examples/client/ClientExecuteProxy.java">Request via a proxy</a><p>This example demonstrates how to send an HTTP request via a proxy.</p></li><li><a href="./httpclient/examples/org/apache/http/examples/client/ClientProxyAuthentication.java">Proxy authentication</a><p>A simple example showing execution of an HTTP request over a secure connection tunneled through an authenticating proxy. </p></li><li><a href="./httpclient/examples/org/apache/http/examples/client/ClientChunkEncodedPost.java">Chunk encoded POST</a><p>This example shows how to stream out a request entity using chunk encoding.</p></li><li><a href="./httpclient/examples/org/apache/http/examples/client/ClientCustomContext.java">Custom execution context</a><p>This example demonstrates the use of a local HTTP context populated custom attributes.</p></li><li><a href="./httpclient/examples/org/apache/http/examples/client/ClientFormLogin.java">Form based logon</a><p>This example demonstrates how HttpClient can be used to perform form-based logon.</p></li><li><a href="./httpclient/examples/org/apache/http/examples/client/ClientMultiThreadedExecution.java">Threaded request execution</a><p>An example that executes HTTP requests from multiple worker threads.</p></li><li><a href="./httpclient/examples/org/apache/http/examples/client/ClientCustomSSL.java">Custom SSL context</a><p>This example demonstrates how to create secure connections with a custom SSL context.</p></li><li><a href="./httpclient/examples/org/apache/http/examples/client/ClientGZipContentCompression.java">Custom protocol interceptors</a><p>This example shows the use of protocol interceptors to transparently modify properties of HTTP messages sent / received by the HTTP client.</p><p>In this particular case HTTP client is made capable of transparent content GZIP compression by adding two protocol interceptors: a request interceptor that adds 'Accept-Encoding: gzip' header to all outgoing requests and a response interceptor that automatically expands compressed response entities by wrapping them with a uncompressing decorator class. The use of protocol interceptors makes content compression completely transparent to the consumer of the HttpClient interface.</p></li><li><a href="./httpclient/examples/org/apache/http/examples/client/ClientPreemptiveBasicAuthentication.java">Preemptive BASIC authentication</a><p>This example shows how HttpClient can be customized to authenticate preemptively using BASIC scheme. Generally, preemptive authentication can be considered less secure than a response to an authentication challenge and therefore discouraged.</p></li><li><a href="./httpclient/examples/org/apache/http/examples/client/ClientPreemptiveDigestAuthentication.java">Preemptive DIGEST authentication</a><p>This example shows how HttpClient can be customized to authenticate preemptively using DIGEST scheme. Generally, preemptive authentication can be considered less secure than a response to an authentication challenge and therefore discouraged.</p></li><li><a href="./httpclient/examples/org/apache/http/examples/client/ProxyTunnelDemo.java">Proxy tunnel</a><p>This example shows how to use ProxyClient in order to establish a tunnel through an HTTP proxy for an arbitrary protocol.</p></li><li><a href="./httpmime/examples/org/apache/http/examples/entity/mime/ClientMultipartFormPost.java">Multipart encoded request entity</a><p>This example shows how to execute requests enclosing a multipart encoded entity. </p></li></ul></div>
      </div>
    </div>
    <div class="clear">
      <hr/>
    </div>
    <div id="footer">
                      
<div class="xleft">Apache HttpComponents, Commons HttpClient, Apache, the Apache feather logo, and the Apache HttpComponents project logo are trademarks of The Apache Software Foundation.</div>
            
<br/>
            
<div class="xleft">All other marks mentioned may be trademarks or registered trademarks of their respective owners.</div>
                <div class="xright">Copyright &#169;                    1999-2013
                        <a href="http://www.apache.org/">The Apache Software Foundation</a>.
            All Rights Reserved.      
        
      </div>
      <div class="clear">
        <hr/>
      </div>
    </div>
  </body>
</html>
